Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/authentication.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/authentication.py	(revision 7233)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/authentication.py	(revision 7234)
@@ -245,7 +245,4 @@
         return None
 
-    def getAccount(self, login):
-        return None
-
 class ApplicantsAuthUtility(grok.GlobalUtility):
     """A global utility that sets up any PAU passed.
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt	(revision 7233)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/browser.txt	(revision 7234)
@@ -45,5 +45,5 @@
   >>> print browser.contents
   <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
-  ...>Required input is missing...
+  ...Required input is missing...
   ...
 
@@ -187,5 +187,6 @@
   ...
 
-We fill the form and try to send message to contact@waeup.org)::
+We fill the form  (this will send a real message to
+contact@waeup.org)::
 
   >>> browser.open('http://localhost/myuniversity/contactadmin')
@@ -194,8 +195,10 @@
   >>> print browser.contents
   <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"...
-  ...<li class="message">You don't have a user account.</li>
-  ...
-
-We can't send messages without a user account.
+  ...<li class="message">Your message has been sent.</li>
+  ...
+
+If this test fails, chances are, that the local machine has no SMTP
+server installed.
+
 
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py	(revision 7233)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/pages.py	(revision 7234)
@@ -216,11 +216,10 @@
     @grok.action('Send message now')
     def send(self, *args, **data):
-        useraccount = self.get_user_account
-        if useraccount is None:
-            self.flash("You don't have a user account.")
-            return
-        fullname = useraccount.title
-        email_from = useraccount.email
-        username = useraccount.name
+        fullname = self.request.principal.title
+        try:
+            email_from = self.request.principal.email
+        except AttributeError:
+            email_from = self.config.email_admin
+        username = self.request.principal.id
         body = data['body']
         email_to = self.config.email_admin
@@ -462,11 +461,10 @@
     @grok.action('Send message now')
     def send(self, *args, **data):
-        useraccount = self.get_user_account
-        if useraccount is None:
-            self.flash("You don't have a user account.")
-            return
-        fullname = useraccount.title
-        email_from = useraccount.email
-        username = useraccount.name
+        fullname = self.request.principal.title
+        try:
+            email_from = self.request.principal.email
+        except AttributeError:
+            email_from = self.config.email_admin
+        username = self.request.principal.id
         body = data['body']
         email_to = self.context.email
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7233)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7234)
@@ -375,11 +375,10 @@
     @grok.action('Send message now')
     def send(self, *args, **data):
-        useraccount = self.get_user_account
-        if useraccount is None:
-            self.flash("You don't have a user account.")
-            return
-        fullname = useraccount.title
-        email_from = useraccount.email
-        username = useraccount.name
+        fullname = self.request.principal.title
+        try:
+            email_from = self.request.principal.email
+        except AttributeError:
+            email_from = self.config.email_admin
+        username = self.request.principal.id
         body = data['body']
         #subject = u'Mail from SIRP'
Index: main/waeup.sirp/trunk/src/waeup/sirp/utils/helpers.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/utils/helpers.py	(revision 7233)
+++ main/waeup.sirp/trunk/src/waeup/sirp/utils/helpers.py	(revision 7234)
@@ -477,9 +477,6 @@
     """
     principal_id = request.principal.id
-    authenticators = getUtilitiesFor(IAuthenticatorPlugin)
-    for authenticator in authenticators:
-        account = authenticator[1].getAccount(principal_id)
-        if account:
-            break
+    authenticator = getUtility(IAuthenticatorPlugin, name='users')
+    account = authenticator.getAccount(principal_id)
     return account
 