Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7253)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7254)
@@ -490,10 +490,4 @@
         return ''
 
-    def formatDatetime(self,datetimeobj):
-        if isinstance(datetimeobj, datetime):
-            return datetimeobj.strftime("%Y-%m-%d %H:%M:%S")
-        else:
-            return None
-
 class AcceptanceFeePaymentAddPage(grok.View):
     """ Page to add an online payment ticket
@@ -889,10 +883,4 @@
         return
 
-    def formatDatetime(self,datetimeobj):
-        if isinstance(datetimeobj, datetime):
-            return datetimeobj.strftime("%Y-%m-%d %H:%M:%S")
-        else:
-            return None
-
     def unremovable(self, ticket):
         usertype = getattr(self.request.principal, 'user_type', None)
Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicantdisplaypage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicantdisplaypage.pt	(revision 7253)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicantdisplaypage.pt	(revision 7254)
@@ -59,6 +59,6 @@
       <td> <a tal:attributes="href value/__name__">
       <span tal:content="value/p_id">PID</span></a></td>
-      <td tal:content="python: view.formatDatetime(value.creation_date)">CREATION DATE</td>
-      <td tal:content="python: view.formatDatetime(value.payment_date)">PAYMENT DATE</td>
+      <td tal:content="python: layout.formatDatetime(value.creation_date)">CREATION DATE</td>
+      <td tal:content="python: layout.formatDatetime(value.payment_date)">PAYMENT DATE</td>
       <td tal:content ="value/category">CATEGORY</td>
       <td tal:content ="value/p_item">ITEM</td>
Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicanteditpage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicanteditpage.pt	(revision 7253)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicanteditpage.pt	(revision 7254)
@@ -127,6 +127,6 @@
         <td> <a tal:attributes="href cl/__name__">
         <span tal:content="cl/p_id">PID</span></a></td>
-        <td tal:content="python: view.formatDatetime(cl.creation_date)">CREATION DATE</td>
-        <td tal:content="python: view.formatDatetime(cl.payment_date)">PAYMENT DATE</td>
+        <td tal:content="python: layout.formatDatetime(cl.creation_date)">CREATION DATE</td>
+        <td tal:content="python: layout.formatDatetime(cl.payment_date)">PAYMENT DATE</td>
       <td tal:content ="cl/category">CATEGORY</td>
       <td tal:content ="cl/p_item">ITEM</td>
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py	(revision 7253)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py	(revision 7254)
@@ -20,4 +20,5 @@
 import os
 import grok
+from datetime import date, datetime
 import grokcore.view
 from hurry.resource import mode
@@ -202,4 +203,10 @@
         return
 
+    def formatDatetime(self,datetimeobj):
+        if isinstance(datetimeobj, datetime):
+            return datetimeobj.strftime("%Y-%m-%d %H:%M:%S")
+        else:
+            return None
+
     def update(self):
         """Include the resources required by the chosen skin/theme.
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7253)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7254)
@@ -959,10 +959,4 @@
 #    pnav = 4
 
-#    def formatDatetime(self,datetimeobj):
-#        if isinstance(datetimeobj, datetime):
-#            return datetimeobj.strftime("%Y-%m-%d %H:%M:%S")
-#        else:
-#            return None
-
 #    @property
 #    def label(self):
@@ -991,10 +985,4 @@
             return False
         return (self.request.principal.user_type == 'student' and ticket.r_code)
-
-    def formatDatetime(self,datetimeobj):
-        if isinstance(datetimeobj, datetime):
-            return datetimeobj.strftime("%Y-%m-%d %H:%M:%S")
-        else:
-            return None
 
     @property
@@ -1258,10 +1246,4 @@
     pnav = 4
     officers_only_actions = ['Remove selected']
-
-    def formatDatetime(self,datetimeobj):
-        if isinstance(datetimeobj, datetime):
-            return datetimeobj.strftime("%Y-%m-%d %H:%M:%S")
-        else:
-            return None
 
     @property
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/accommodationmanagepage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/accommodationmanagepage.pt	(revision 7253)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/accommodationmanagepage.pt	(revision 7254)
@@ -34,5 +34,5 @@
         <td> <a tal:attributes="href cl/__name__">
         <span tal:content="python: cl.getSessionString()">PID</span></a></td>
-        <td tal:content="python: view.formatDatetime(cl.booking_date)">DATE</td>
+        <td tal:content="python: layout.formatDatetime(cl.booking_date)">DATE</td>
         <td tal:content="cl/bed_coordinates">COORDINATES</td>
         <td tal:content="cl/bed_type">TYPE</td>
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/paymentsmanagepage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/paymentsmanagepage.pt	(revision 7253)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/paymentsmanagepage.pt	(revision 7254)
@@ -37,6 +37,6 @@
         <td> <a tal:attributes="href cl/__name__">
         <span tal:content="cl/p_id">PID</span></a></td>
-        <td tal:content="python: view.formatDatetime(cl.creation_date)">CREATION DATE</td>
-        <td tal:content="python: view.formatDatetime(cl.payment_date)">PAYMENT DATE</td>
+        <td tal:content="python: layout.formatDatetime(cl.creation_date)">CREATION DATE</td>
+        <td tal:content="python: layout.formatDatetime(cl.payment_date)">PAYMENT DATE</td>
       <td tal:content ="cl/category">CATEGORY</td>
       <td tal:content ="cl/p_item">ITEM</td>
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/paymentspage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/paymentspage.pt	(revision 7253)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/paymentspage.pt	(revision 7254)
@@ -19,6 +19,6 @@
       <td> <a tal:attributes="href value/__name__">
       <span tal:content="value/p_id">PID</span></a></td>
-      <td tal:content="python: view.formatDatetime(value.creation_date)">CREATION DATE</td>
-      <td tal:content="python: view.formatDatetime(value.payment_date)">PAYMENT DATE</td>
+      <td tal:content="python: layout.formatDatetime(value.creation_date)">CREATION DATE</td>
+      <td tal:content="python: layout.formatDatetime(value.payment_date)">PAYMENT DATE</td>
       <td tal:content ="value/category">CATEGORY</td>
       <td tal:content ="value/p_item">ITEM</td>