Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/applicant.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/applicant.py	(revision 7254)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/applicant.py	(revision 7255)
@@ -33,5 +33,4 @@
     IApplicant, IApplicantEdit,
     )
-from waeup.sirp.applicants.workflow import INITIALIZED
 
 def generate_applicant_id(container=None):
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/authentication.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/authentication.py	(revision 7254)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/authentication.py	(revision 7255)
@@ -20,15 +20,6 @@
 """
 import grok
-from zope.component import getUtility
-from zope.password.interfaces import IPasswordManager
-from zope.pluggableauth.interfaces import (
-    IAuthenticatorPlugin, ICredentialsPlugin)
-from zope.pluggableauth.plugins.session import (
-    SessionCredentialsPlugin, SessionCredentials)
-from zope.publisher.interfaces.http import IHTTPRequest
-from zope.session.interfaces import ISession
-from waeup.sirp.authentication import SIRPPrincipalInfo, get_principal_role_manager
-from waeup.sirp.interfaces import (
-    IAuthPluginUtility, IUserAccount, IPasswordValidator)
+from zope.pluggableauth.interfaces import IAuthenticatorPlugin
+from waeup.sirp.interfaces import IAuthPluginUtility, IUserAccount
 from waeup.sirp.applicants.interfaces import IApplicant
 from waeup.sirp.students.authentication import (
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7254)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7255)
@@ -22,12 +22,7 @@
 import grok
 from time import time
-from datetime import datetime, date
-from zope.authentication.interfaces import ILogout, IAuthentication
+from datetime import datetime
 from zope.component import getUtility, createObject
-from zope.formlib.widget import CustomWidgetFactory
 from zope.formlib.form import setUpEditWidgets
-from zope.securitypolicy.interfaces import IPrincipalRoleManager
-from zope.traversing.browser import absoluteURL
-
 from hurry.workflow.interfaces import IWorkflowInfo, IWorkflowState
 from reportlab.pdfgen import canvas
@@ -38,7 +33,4 @@
     Table, Spacer)
 from reportlab.platypus.tables import TableStyle
-
-from waeup.sirp.accesscodes import invalidate_accesscode, get_access_code
-from waeup.sirp.accesscodes.workflow import USED
 from waeup.sirp.browser import (
     WAeUPPage, WAeUPEditFormPage, WAeUPAddFormPage, WAeUPDisplayFormPage)
@@ -47,7 +39,5 @@
 from waeup.sirp.browser.pages import add_local_role, del_local_roles
 from waeup.sirp.browser.resources import datepicker, tabs, datatable
-from waeup.sirp.browser.viewlets import (
-    ManageActionButton, PrimaryNavTab, LeftSidebarLink
-    )
+from waeup.sirp.browser.viewlets import ManageActionButton, PrimaryNavTab
 from waeup.sirp.interfaces import (
     IWAeUPObject, ILocalRolesAssignable, IExtFileStore,
@@ -61,7 +51,4 @@
     FriendlyDatetimeDisplayWidget)
 from waeup.sirp.widgets.restwidget import ReSTDisplayWidget
-from waeup.sirp.widgets.objectwidget import (
-    WAeUPObjectWidget, WAeUPObjectDisplayWidget)
-from waeup.sirp.applicants import Applicant, get_applicant_data
 from waeup.sirp.applicants.interfaces import (
     IApplicant, IApplicantEdit, IApplicantsRoot,
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/dynamicroles.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/dynamicroles.py	(revision 7254)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/dynamicroles.py	(revision 7255)
@@ -23,10 +23,5 @@
 """
 import grok
-from zope.securitypolicy.interfaces import (
-    IPrincipalRoleManager, IPrincipalPermissionManager,)
-from zope.securitypolicy.principalrole import AnnotationPrincipalRoleManager
-from zope.securitypolicy.principalpermission import (
-    AnnotationPrincipalPermissionManager,)
-from zope.securitypolicy.settings import Allow, Deny, Unset
+from zope.securitypolicy.interfaces import IPrincipalRoleManager
 from waeup.sirp.applicants.interfaces import IApplicant
 from waeup.sirp.students.dynamicroles import StudentPrincipalRoleManager
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/interfaces.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/interfaces.py	(revision 7254)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/interfaces.py	(revision 7255)
@@ -18,6 +18,4 @@
 """Interfaces of the university application package.
 """
-import os
-import re
 
 from grokcore.content.interfaces import IContainer
@@ -26,6 +24,4 @@
 from zope.interface import Interface, Attribute
 from zope.component import getUtilitiesFor
-from zope.pluggableauth.interfaces import IPrincipalInfo
-from zope.security.interfaces import IGroupClosureAwarePrincipal as IPrincipal
 from zc.sourcefactory.basic import BasicSourceFactory
 from waeup.sirp.interfaces import (
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/payment.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/payment.py	(revision 7254)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/payment.py	(revision 7255)
@@ -34,5 +34,4 @@
     def __init__(self):
         super(ApplicantOnlinePayment, self).__init__()
-        p_id = None
         return
 
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_applicant.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_applicant.py	(revision 7254)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_applicant.py	(revision 7255)
@@ -19,8 +19,6 @@
 """
 import grok
-import os
 import shutil
 import tempfile
-import unittest
 from StringIO import StringIO
 from zope.component import adapts, queryUtility
@@ -32,5 +30,5 @@
 from waeup.sirp.interfaces import IFileStoreHandler, IFileStoreNameChooser
 from waeup.sirp.applicants import (
-    Applicant, ApplicantFactory, ApplicantsContainer,
+    Applicant, ApplicantFactory,
     ApplicantImageStoreHandler, ApplicantImageNameChooser,
     )
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_authentication.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_authentication.py	(revision 7254)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_authentication.py	(revision 7255)
@@ -23,5 +23,4 @@
 from zope.password.interfaces import IPasswordManager
 from zope.pluggableauth import PluggableAuthentication
-from zope.security.interfaces import Unauthorized
 from zope.securitypolicy.role import Role
 from zope.securitypolicy.interfaces import IRole, Allow
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_dynamicroles.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_dynamicroles.py	(revision 7254)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_dynamicroles.py	(revision 7255)
@@ -21,6 +21,5 @@
 from zope.interface import verify
 from zope.securitypolicy.interfaces import IPrincipalRoleManager
-from zope.securitypolicy.settings import Allow, Deny, Unset
-from zope.securitypolicy.tests.test_securitymap import TestSecurityMap
+from zope.securitypolicy.settings import Allow
 from zope.securitypolicy.tests.test_annotationprincipalrolemanager import (
     Test as APRMTest, Manageable)