Index: main/waeup.sirp/trunk/src/waeup/sirp/hostels/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/hostels/browser.py	(revision 7256)
+++ main/waeup.sirp/trunk/src/waeup/sirp/hostels/browser.py	(revision 7257)
@@ -20,22 +20,14 @@
 import grok
 import sys
-from time import time
-from datetime import date, datetime
-from zope.component import createObject
 from waeup.sirp.browser import (
     WAeUPEditFormPage, WAeUPAddFormPage, WAeUPDisplayFormPage,
     NullValidator)
 from waeup.sirp.browser.breadcrumbs import Breadcrumb
-from waeup.sirp.browser.resources import datepicker, datatable, tabs, toggleall
+from waeup.sirp.browser.resources import datepicker, datatable, tabs
 from waeup.sirp.browser.layout import default_primary_nav_template
 from waeup.sirp.browser.pages import delSubobjects
 from waeup.sirp.browser.viewlets import (
-    ManageActionButton, PrimaryNavTab, AddActionButton)
-from waeup.sirp.interfaces import IWAeUPObject, IUserAccount
-from waeup.sirp.widgets.datewidget import (
-    FriendlyDateWidget, FriendlyDateDisplayWidget,
-    FriendlyDatetimeDisplayWidget)
-from waeup.sirp.authentication import get_principal_role_manager
-from waeup.sirp.hostels.container import HostelsContainer
+    ManageActionButton, PrimaryNavTab)
+from waeup.sirp.interfaces import IWAeUPObject
 from waeup.sirp.hostels.vocabularies import NOT_OCCUPIED
 from waeup.sirp.hostels.hostel import Hostel
@@ -50,5 +42,4 @@
 # Save function used for save methods in manager pages
 def msave(view, **data):
-    form = view.request.form
     changed_fields = view.applyData(view.context, **data)
     # Turn list of lists into single list
Index: main/waeup.sirp/trunk/src/waeup/sirp/hostels/catalog.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/hostels/catalog.py	(revision 7256)
+++ main/waeup.sirp/trunk/src/waeup/sirp/hostels/catalog.py	(revision 7257)
@@ -20,9 +20,5 @@
 import grok
 from grok import index
-from hurry.query import Eq, Text
-from hurry.query.query import Query
-from zope.catalog.interfaces import ICatalog
-from zope.component import queryUtility
-from waeup.sirp.interfaces import IUniversity, IQueryResultItem
+from waeup.sirp.interfaces import IUniversity
 from waeup.sirp.hostels.interfaces import IBed
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/hostels/container.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/hostels/container.py	(revision 7256)
+++ main/waeup.sirp/trunk/src/waeup/sirp/hostels/container.py	(revision 7257)
@@ -20,7 +20,6 @@
 """
 import grok
-from grok import index
 from waeup.sirp.hostels.interfaces import IHostelsContainer, IHostel
-from waeup.sirp.utils.helpers import attrs_to_fields, get_current_principal
+from waeup.sirp.utils.helpers import get_current_principal
 from waeup.sirp.utils.logger import Logger
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/hostels/hostel.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/hostels/hostel.py	(revision 7256)
+++ main/waeup.sirp/trunk/src/waeup/sirp/hostels/hostel.py	(revision 7257)
@@ -22,5 +22,4 @@
 from zope.event import notify
 from datetime import datetime
-from grok import index
 from waeup.sirp.utils.helpers import attrs_to_fields
 from waeup.sirp.hostels.vocabularies import NOT_OCCUPIED
Index: main/waeup.sirp/trunk/src/waeup/sirp/hostels/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/hostels/interfaces.py	(revision 7256)
+++ main/waeup.sirp/trunk/src/waeup/sirp/hostels/interfaces.py	(revision 7257)
@@ -16,5 +16,5 @@
 ## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 ##
-from zope.interface import Attribute, invariant, Invalid
+from zope.interface import invariant, Invalid
 from zope import schema
 from waeup.sirp.interfaces import IWAeUPObject
Index: main/waeup.sirp/trunk/src/waeup/sirp/hostels/vocabularies.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/hostels/vocabularies.py	(revision 7256)
+++ main/waeup.sirp/trunk/src/waeup/sirp/hostels/vocabularies.py	(revision 7257)
@@ -22,5 +22,4 @@
 from zope.catalog.interfaces import ICatalog
 from zc.sourcefactory.contextual import BasicContextualSourceFactory
-from zc.sourcefactory.basic import BasicSourceFactory
 from waeup.sirp.interfaces import SimpleWAeUPVocabulary
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_dynamicroles.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_dynamicroles.py	(revision 7256)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_dynamicroles.py	(revision 7257)
@@ -21,6 +21,5 @@
 from zope.interface import verify
 from zope.securitypolicy.interfaces import IPrincipalRoleManager
-from zope.securitypolicy.settings import Allow, Deny, Unset
-from zope.securitypolicy.tests.test_securitymap import TestSecurityMap
+from zope.securitypolicy.settings import Allow
 from zope.securitypolicy.tests.test_annotationprincipalrolemanager import (
     Test as APRMTest, Manageable)