Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7258)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7259)
@@ -477,4 +477,10 @@
         return ''
 
+class ApplicantBaseDisplayFormPage(ApplicantDisplayFormPage):
+    grok.context(IApplicant)
+    grok.name('base')
+    form_fields = grok.AutoFields(IApplicant).select(
+        'applicant_id', 'firstname', 'lastname','email', 'course1')
+
 class AcceptanceFeePaymentAddPage(grok.View):
     """ Page to add an online payment ticket
@@ -625,5 +631,5 @@
             self.redirect(self.url(self.context))
             return
-        applicantview = ApplicantDisplayFormPage(self.context.__parent__,
+        applicantview = ApplicantBaseDisplayFormPage(self.context.__parent__,
             self.request)
         students_utils = getUtility(IStudentsUtils)
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py	(revision 7258)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py	(revision 7259)
@@ -286,6 +286,7 @@
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
         self.assertEqual(self.browser.url, self.add_applicant_path)
-        self.browser.getControl(name="form.firstname").value = 'Albert'
-        self.browser.getControl(name="form.lastname").value = 'Einstein'
+        self.browser.getControl(name="form.firstname").value = 'Alois'
+        self.browser.getControl(name="form.middlenames").value = 'Kofi'
+        self.browser.getControl(name="form.lastname").value = 'Bettermann'
         self.browser.getControl(name="form.email").value = 'xx@yy.zz'
         self.browser.getControl("Create application record").click()
@@ -313,4 +314,5 @@
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
         self.fill_correct_values()
+        # Fire transition
         self.browser.getControl(name="transition").value = ['start']
         self.browser.getControl("Save").click()
@@ -319,10 +321,19 @@
         self.browser.open(self.view_path)
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
-        self.browser.open(self.slip_path)
-        self.assertEqual(self.browser.headers['Status'], '200 Ok')
-        self.assertEqual(self.browser.headers['Content-Type'], 'application/pdf')
+        # Change course_admitted
         self.browser.open(self.manage_path)
         self.browser.getControl(name="form.course_admitted").value = []
         self.browser.getControl("Save").click()
+        self.assertMatches('...Form has been saved...', self.browser.contents)
+        # Change password
+        self.browser.getControl(name="password").value = 'secret'
+        self.browser.getControl(name="control_password").value = 'secre'
+        self.browser.getControl("Save").click()
+        self.assertMatches('...Passwords do not match...', self.browser.contents)
+        self.browser.getControl(name="password").value = 'secret'
+        self.browser.getControl(name="control_password").value = 'secret'
+        self.browser.getControl("Save").click()
+        self.assertMatches('...Form has been saved...', self.browser.contents)
+        # Open pdf slip
         self.browser.open(self.slip_path)
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7258)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 7259)
@@ -56,5 +56,4 @@
 from waeup.sirp.students.vocabularies import StudyLevelSource
 from waeup.sirp.browser.resources import toggleall
-from waeup.sirp.authentication import get_principal_role_manager
 from waeup.sirp.hostels.hostel import NOT_OCCUPIED
 from waeup.sirp.utils.helpers import send_mail